<template>
  <Modal v-model="isShow" :close="closeModal">
    <div class="modal">
      <div>
        <p class="titleNewFileComponent">Archivos del computador</p>
        <p class="classMessage titleNewFileComponent">{{ dialogText }}</p>
        <!-- <input type="file" name="inputFile" /> -->
        <p class="classMessage titleNewFileComponent">{{ errorLoadFile }}</p>
        <input type="file" @change="fileSelectForUser" />
      </div>
      <button v-on:click="closeModal">Cancelar</button>
    </div>
  </Modal>
</template>

<script lang="ts">
import { defineComponent, ref, watch, onMounted } from "vue";
import { getFileHandle } from "../../host/index";

export default defineComponent({
  props: ["message", "trigger"],
  emits: ["setFileProject"],
  setup(props, context) {
    const isShow = ref(false);
    const dialogText = ref();
    const errorLoadFile = ref();

    function showModal() {
      isShow.value = true;
    }

    function closeModal() {
      isShow.value = false;
      context.emit("setFileProject", undefined);
    }

    watch(
      () => props.trigger,
      (msg, oldMsg) => {
        dialogText.value = props.message;
        console.log(
          "watch: ",
          "trigger value actual: ",
          msg,
          "\ntrigger value old: ",
          oldMsg,
          "\nthis message: ",
          dialogText.value
        );
        if (msg) {
          showModal();
        } else {
          closeModal();
        }
      }
    );

    onMounted(() => {
      // console.log(props.parentMessage)
    });

    const fileSelectForUser = async (event) => {
      const files = event.target.files;
      if (files[0] != undefined) {
        const fileObj = await getFileHandle(files[0]);
        if (fileObj.file != undefined) {
          context.emit("setFileProject", fileObj.file);
        } else {
          errorLoadFile.value = fileObj.log;
        }
      }
    };

    return {
      isShow,
      showModal,
      closeModal,
      dialogText,
      errorLoadFile,
      //-- METHODS --
      fileSelectForUser,
    };
  },
});
</script>

<style>
.modal {
  width: auto;
  /* width: 300px;*/
  padding: 10px;
  box-sizing: border-box;
  background-color: #fff;
  font-size: 20px;
  text-align: center;
  position: absolute;
  top: 20px;
  bottom: 20px;
  overflow: scroll;
}
.classMessage {
  height: auto;
  text-align: left;
  white-space: pre; /* habilita \n y \t para <p> */
}
.vue-universal-modal {
  z-index: 71;
}
.titleNewFileComponent {
  color: black;
}
</style>
